#!/bin/sh

#
# *NOTE* This should be used by developers only!
#
# This is a simple script used to print the lines of files that leaked 
# memory.  It is expected to be used as such:
#
#  gnapster | ./d_memleak.sh
#

if [ -x /usr/local/bin/get_line ]; then
 GET_LINE="1"
else
 GET_LINE="0"
fi

cat /dev/stdin > gnapster.out
LINES=`cat gnapster.out | wc -l`
L2=`echo $LINES"-2" | bc`
L3=`echo $L2"-2" | bc`

for i in `head -$L2 gnapster.out | tail -$l3 | tr ' ' '_' | tr '\t' '_'`; do
 DATA=`echo $i | tr '_' ' '`;
 FILE=`echo $DATA | awk -F' ' '{print $2}'`;
 LINE=`echo $DATA | awk -F' ' '{print $3}'`;
 if [ $GET_LINE = "1" ]; then
  TEXT=`get_line $FILE $LINE | xargs`;
 else
  TEXT=`cat $FILE | head -\`echo $LINE\` | tail -1 | xargs`;
 fi
 printf "%-11s:%-4i %s\n" "$FILE" "$LINE" "$TEXT"
# echo -en $FILE":"$LINE", ";
# cat $FILE | head -`echo $LINE` | tail -1;
done

if [ -f gnapster.out ]; then
 rm -f gnapster.out
fi
